class _Solos:
    def __init__(self, stats: dict):
        self._stats = stats
        self.wins = stats["wins"]
        self.losses = stats["losses"]
        self.draws = stats["draws"]
        self.kills = stats["kills"]
        self.deaths = stats["deaths"]
        self.goals = stats["goals"]
        self.winstreak, self.ws = stats["winstreak"]
        self.bestwinstreak, self.bestws = stats["bestWinstreak"]


class _Doubles:
    def __init__(self, stats: dict):
        self._stats = stats
        self.wins = stats["wins"]
        self.losses = stats["losses"]
        self.draws = stats["draws"]
        self.kills = stats["kills"]
        self.deaths = stats["deaths"]
        self.goals = stats["goals"]
        self.winstreak, self.ws = stats["winstreak"]
        self.bestwinstreak, self.bestws = stats["bestWinstreak"]


class _Threes:
    def __init__(self, stats: dict):
        self._stats = stats
        self.wins = stats["wins"]
        self.losses = stats["losses"]
        self.draws = stats["draws"]
        self.kills = stats["kills"]
        self.deaths = stats["deaths"]
        self.goals = stats["goals"]
        self.winstreak, self.ws = stats["winstreak"]
        self.bestwinstreak, self.bestws = stats["bestWinstreak"]


class _Fours:
    def __init__(self, stats: dict):
        self._stats = stats
        self.wins = stats["wins"]
        self.losses = stats["losses"]
        self.draws = stats["draws"]
        self.kills = stats["kills"]
        self.deaths = stats["deaths"]
        self.goals = stats["goals"]
        self.winstreak, self.ws = stats["winstreak"]
        self.bestwinstreak, self.bestws = stats["bestWinstreak"]


class _Overall:
    def __init__(self, stats: dict):
        self._stats = stats
        self.wins = stats["wins"]
        self.losses = stats["losses"]
        self.draws = stats["draws"]
        self.kills = stats["kills"]
        self.deaths = stats["deaths"]
        self.goals = stats["goals"]
        self.winstreak, self.ws = stats["winstreak"]
        self.bestwinstreak, self.bestws = stats["bestWinstreak"]


class _Stats:
    def __init__(self, stats: dict):
        self._stats = stats
        self.overall = _Overall(stats["overall"])
        self.solos = _Solos(stats["solos"])
        self.doubles, self.doubles = _Doubles(stats["doubles"])
        self.threes, self.trios, self.triples = _Threes(stats["threes"])
        self.fours = _Fours(stats["fours"])
        
    def __str__(self):
        return self._stats


class Stats:
    def __init__(self, data: dict):
        self._data = data
        self.success = data["success"]
        self.uuid = data["uuid"]
        self.name = data["name"]
        self.title = data["title"]
        self.rankcolor = data["rankcolor"]
        self.stats = _Stats(data["stats"])
        self.favoritemaps = data["favoritemaps"]
    
    def __str__(self):
        return self._data


__all__ = Stats
